SystemOrganization addCategory: #GhostProxies!

Object subclass: #MethodProxy
	instanceVariableNames: 'target handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!MethodProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 11:44'!
proxyFor: anObject
	 | aProxy |
       aProxy := self new.
       aProxy target: anObject.
       aProxy handler: SimpleForwarderHandler new. 
	 MethodProxyTrap initialize.
       MethodProxyTrap adoptInstance: aProxy.
       ^ aProxy.! !

!MethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 12:16'!
cannotInterpret: aMessage
       ^ handler handleInterception: aMessage for: target! !

!MethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 11:43'!
handler
	^ handler! !

!MethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 11:43'!
handler: anObject
	handler := anObject! !

!MethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 11:43'!
target
	^ target! !

!MethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 11:43'!
target: anObject
	target := anObject! !

MethodProxy subclass: #MethodProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!MethodProxyTrap classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 11:44'!
initialize
	superclass := MethodProxy.
	format := MethodProxy format.
	methodDict := nil.! !

Object subclass: #ObjectProxy
	instanceVariableNames: 'target handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 11:03'!
proxyFor: anObject
	 | aProxy |
       aProxy := self new.
       aProxy target: anObject.
       aProxy handler: SimpleForwarderHandler new. 
	 ObjectProxyTrap initialize.
       ObjectProxyTrap adoptInstance: aProxy.
       ^ aProxy.! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 12:26'!
cannotInterpret: aMessage
       ^ handler handleInterception: aMessage for: target! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 10:59'!
handler
	^ handler! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 10:59'!
handler: anObject
	handler := anObject! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 10:59'!
target
	^ target! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 10:59'!
target: anObject
	target := anObject! !

ObjectProxy subclass: #ObjectProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ObjectProxyTrap classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 10:58'!
initialize
	superclass := ObjectProxy.
	format := ObjectProxy format.
	methodDict := nil.! !

Object subclass: #SimpleForwarderHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 12:23'!
flushCacheOf: aCompiledMethod
	^ aCompiledMethod selector flushCache	 
		! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 12:22'!
handleInterception: aMessage for: aTargetObject
	Transcript show: 'message ', aMessage selector, ' intercepted and will be forwarded'; cr.
	(self isMethodExecutionInterception: aMessage)  ifTrue: [
		^ self handleMethodExecution: aMessage method: aTargetObject
		].
	(self isMethodFlushCache: aMessage)  ifTrue: [
		^ self flushCacheOf: aTargetObject  
		].
	^ aMessage sendTo: aTargetObject ! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 12:10'!
handleMethodExecution: aMessage method: aTargetObject 
	"aMessage selector is the run:with:in: 
	"
	Transcript show: 'message ', aMessage selector, ' execution intercepted and will be forwarded'; cr.
	^ aTargetObject valueWithReceiver: aMessage arguments third arguments: aMessage arguments second
	
! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 12:07'!
isMethodExecutionInterception: aMessage
	^ aMessage selector = #run:with:in:! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 12:22'!
isMethodFlushCache: aMessage
	^ aMessage selector = #flushCache! !

Object subclass: #User
	instanceVariableNames: 'username'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!User classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 11:12'!
named: aName
	^ self new username: aName! !

!User methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 11:09'!
username ^ username! !

!User methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 11:08'!
username: anObject
	username := anObject! !

TestCase subclass: #SimpleForwarderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 12:25'!
testSimpleForwardingForMethod
       | aProxy aUser method |
       aUser := User named: 'Kurt'.
       method := User methodDict at: #username.
       aProxy := MethodProxy proxyFor: method. 
      [User methodDict at: #username put: aProxy.
       self assert: aProxy getSource equals: 'username ^ username'. 
  self assert: aUser username equals: 'Kurt'.
	] ensure: [ User methodDict at: #username put: method. ]! !

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 10:57'!
testSimpleForwardingForRegularObject
	| proxy |
	proxy := ObjectProxy proxyFor: (Point x: 3 y: 4). 
	self assert: proxy x equals: 3. 
	self assert: proxy y equals: 4.! !
MethodProxyTrap initialize!
ObjectProxyTrap initialize!
